/*
 * Copyright (C) 1996-1998 by the Board of Trustees
 *    of Leland Stanford Junior University.
 * 
 * This file is part of the SimOS distribution. 
 * See LICENSE file for terms of the license. 
 *
 */

/*
 * bootslave.c -- program to run on top of SIMOS to launch a slave kernel
 *
 */

#define HIVE
#include "simosapps.h"
#include "stdio.h"
#include "sys/sysmp.h"

int main(int argc, char** argv)
{
   int cellid;
   char* image;
   char buf[1024];
   int i, err;
   if (argc < 3) {
      printf("usage: bootslave cellid image_file args\n");
      return 1;
   }
   
   cellid = atoi(argv[1]);
   image = argv[2];
   buf[0] = '\0';
   for (i=3; i<argc; i++) {
      strcat(buf, argv[i]);
      strcat(buf, " ");
   }

   err = sysmp(MP_HIVE, MPHI_BOOTSLAVE, cellid, image, buf);
   if (err) {
      perror("booting slave");
   }
   return 0;
}
