/*
 * Copyright (C) 1996-1998 by the Board of Trustees
 *    of Leland Stanford Junior University.
 * 
 * This file is part of the SimOS distribution. 
 * See LICENSE file for terms of the license. 
 *
 */

/*
 * remote_access - Interface to the remote file  access routines
 */

#ifndef SIMRMT_H
#define SIMRMT_H

#include "checkpoint.h"

extern void *Simrmt_mmap(void *addr, size_t len, int prot, int flags,
                         char* pathname, off_t off);
extern FILE* Simrmt_RemoteFileOpen(char *pathName);
extern int Simrmt_cptinit(char *fullname, char *rootname);
extern bool Simrmt_access(char *pathname);
extern FILE *Simrmt_fopen(char *pathname);
extern int Simrmt_diskrestorelocal(void);
extern int Simrmt_diskcheckpoint(CptMode mode, int rfd, FILE *cptfile,
                                 int binfd);
extern int Simrmt_diskinit(char *remoteServer);
extern int64 Simrmt_diskcmd(int diskfd, int op,
			  int node, int ctrl, int unit,
			  int64 sectorNum, int64 sizeInBytes, byte *buffer);

#endif /* SIMRMT_H */
