/*
 * Copyright (C) 1996-1998 by the Board of Trustees
 *    of Leland Stanford Junior University.
 * 
 * This file is part of the SimOS distribution. 
 * See LICENSE file for terms of the license. 
 *
 */


#ifndef _SYMEXPR_H_
#define _SYMEXPR_H_

#include "symfile.h"

typedef struct ParseInfo {
   /* scope */
   char *execname;
   char *srcfile;

   /* current string */
   char *str;
   
   /* current symbol state */
   Symb sym;
   Reg value;
   char constant;

   /* read from internal simulator memory */
   char internal;
   
} ParseInfo;


int SymParse(char *symexpr, ParseInfo *pip);

#endif
