/*
 * Copyright (C) 1996-1998 by the Board of Trustees
 *    of Leland Stanford Junior University.
 * 
 * This file is part of the SimOS distribution. 
 * See LICENSE file for terms of the license. 
 *
 */

/*****************************************************************
 * tcl_init.h
 * 
 * 
 *******************************************************************/
#ifndef TCL_INIT_H
#define TCL_INIT_H

#include "simutil.h"
#include "tclsimos.h" 

typedef struct tclcmd {
   char *name;
   int  numargs;
   int  (*cmd)(Tcl_Interp *interp, int argc, char *argv[]);
   char *usage;
} tclcmd;

extern  Tcl_Interp *TCLInterp;
extern int TclIniting;


extern void TCLDefineOption(char *opt, char *val);
extern void TCLInit(char *initFile);

/* callouts to Tcl */
extern unsigned TclTranslateVirtual(int cpuNum, VA vAddr);
extern char*    TclDiskFileName(int machine, int node, int ctrl, int unit);
extern void     TclDoCheckpoint(char* name);
extern void     TclRestoreCheckpoint(char* name);

extern int DispatchCmd(ClientData dummy, Tcl_Interp *interp, int argc, char *argv[]);

extern void HandleError(Tcl_Interp *interp, char *script);

extern char *SearchForFile(char *filename);

extern int String2Reg(Tcl_Interp *interp, char *string, Reg *value);
#endif
