/*
 * Copyright (C) 1998 by the Board of Trustees
 *    of Leland Stanford Junior University.
 * Copyright (C) 1998 Digital Equipment Corporation
 *
 * This file is part of the SimOS distribution.
 * See LICENSE file for terms of the license.
 *
 */


#include "alpha_memref.h"

RefSize alphaRefSizeMap[64] = {
  NO_SZ,		/* op_call_pal */
  NO_SZ,		/* op_opc01 */
  NO_SZ,		/* op_opc02 */
  NO_SZ,		/* op_opc03 */
  NO_SZ,		/* op_opc04 */
  NO_SZ,		/* op_opc05 */
  NO_SZ,		/* op_opc06 */
  NO_SZ,		/* op_opc07 */
  NO_SZ,		/* op_lda */
  NO_SZ,		/* op_ldah */
  BYTE_SZ,		/* op_ldbu */
  DOUBLE_SZ,		/* op_ldq_u */
  HALF_SZ,		/* op_ldwu */
  HALF_SZ,		/* op_stw */
  BYTE_SZ,		/* op_stb */
  DOUBLE_SZ,		/* op_stq_u */
  NO_SZ,		/* op_inta */
  NO_SZ,		/* op_intl */
  NO_SZ,		/* op_ints */
  NO_SZ,		/* op_intm */
  NO_SZ,		/* op_fltm, op_opc14 */
  NO_SZ,		/* op_fltv */
  NO_SZ,		/* op_flti */
  NO_SZ,		/* op_fltl */
  NO_SZ,		/* op_misc */
  NO_SZ,		/* op_pal19 */
  NO_SZ,		/* op_jsr */
  NO_SZ,		/* op_pal1b */
  NO_SZ,		/* op_intmisc */
  NO_SZ,		/* op_pal1d */
  NO_SZ,		/* op_pal1e */
  NO_SZ,		/* op_pal1f */
  WORD_SZ,		/* op_ldf */
  DOUBLE_SZ,		/* op_ldg */
  WORD_SZ,		/* op_lds */
  DOUBLE_SZ,		/* op_ldt */
  WORD_SZ,		/* op_stf */
  DOUBLE_SZ,		/* op_stg */
  WORD_SZ,		/* op_sts */
  DOUBLE_SZ,		/* op_stt */
  WORD_SZ,		/* op_ldl */
  DOUBLE_SZ,		/* op_ldq */
  WORD_SZ,		/* op_ldl_l */
  DOUBLE_SZ,		/* op_ldq_l */
  WORD_SZ,		/* op_stl */
  DOUBLE_SZ,		/* op_stq */
  WORD_SZ,		/* op_stl_c */
  DOUBLE_SZ,		/* op_stq_c */
  NO_SZ,		/* op_br */
  NO_SZ,		/* op_fbeq */
  NO_SZ,		/* op_fblt */
  NO_SZ,		/* op_fble */
  NO_SZ,		/* op_bsr */
  NO_SZ,		/* op_fbne */
  NO_SZ,		/* op_fbge */
  NO_SZ,		/* op_fbgt */
  NO_SZ,		/* op_blbc */
  NO_SZ,		/* op_beq */
  NO_SZ,		/* op_blt */
  NO_SZ,		/* op_ble */
  NO_SZ,		/* op_blbs */
  NO_SZ,		/* op_bne */
  NO_SZ,		/* op_bge */
  NO_SZ			/* op_bgt */
};

RefFlavor alphaRefFlavorMap[64] = {
  NO_FLAVOR,		/* op_call_pal */
  NO_FLAVOR,		/* op_opc01 */
  NO_FLAVOR,		/* op_opc02 */
  NO_FLAVOR,		/* op_opc03 */
  NO_FLAVOR,		/* op_opc04 */
  NO_FLAVOR,		/* op_opc05 */
  NO_FLAVOR,		/* op_opc06 */
  NO_FLAVOR,		/* op_opc07 */
  NO_FLAVOR,		/* op_lda */
  NO_FLAVOR,		/* op_ldah */
  NO_FLAVOR,		/* op_ldbu */
  NO_FLAVOR,		/* op_ldq_u */
  NO_FLAVOR,		/* op_ldwu */
  NO_FLAVOR,		/* op_stw */
  NO_FLAVOR,		/* op_stb */
  NO_FLAVOR,		/* op_stq_u */
  NO_FLAVOR,		/* op_inta */
  NO_FLAVOR,		/* op_intl */
  NO_FLAVOR,		/* op_ints */
  NO_FLAVOR,		/* op_intm */
  NO_FLAVOR,		/* op_fltm, op_opc14 */
  NO_FLAVOR,		/* op_fltv */
  NO_FLAVOR,		/* op_flti */
  NO_FLAVOR,		/* op_fltl */
  NO_FLAVOR,		/* op_misc */
  NO_FLAVOR,		/* op_pal19 */
  NO_FLAVOR,		/* op_jsr */
  NO_FLAVOR,		/* op_pal1b */
  NO_FLAVOR,		/* op_intmisc */
  NO_FLAVOR,		/* op_pal1d */
  NO_FLAVOR,		/* op_pal1e */
  NO_FLAVOR,		/* op_pal1f */
  NO_FLAVOR,		/* op_ldf */
  NO_FLAVOR,		/* op_ldg */
  NO_FLAVOR,		/* op_lds */
  NO_FLAVOR,		/* op_ldt */
  NO_FLAVOR,		/* op_stf */
  NO_FLAVOR,		/* op_stg */
  NO_FLAVOR,		/* op_sts */
  NO_FLAVOR,		/* op_stt */
  NO_FLAVOR,		/* op_ldl */
  NO_FLAVOR,		/* op_ldq */
  LL_FLAVOR,		/* op_ldl_l */
  LL_FLAVOR,		/* op_ldq_l */
  NO_FLAVOR,		/* op_stl */
  NO_FLAVOR,		/* op_stq */
  SC_FLAVOR,		/* op_stl_c */
  SC_FLAVOR,		/* op_stq_c */
  NO_FLAVOR,		/* op_br */
  NO_FLAVOR,		/* op_fbeq */
  NO_FLAVOR,		/* op_fblt */
  NO_FLAVOR,		/* op_fble */
  NO_FLAVOR,		/* op_bsr */
  NO_FLAVOR,		/* op_fbne */
  NO_FLAVOR,		/* op_fbge */
  NO_FLAVOR,		/* op_fbgt */
  NO_FLAVOR,		/* op_blbc */
  NO_FLAVOR,		/* op_beq */
  NO_FLAVOR,		/* op_blt */
  NO_FLAVOR,		/* op_ble */
  NO_FLAVOR,		/* op_blbs */
  NO_FLAVOR,		/* op_bne */
  NO_FLAVOR,		/* op_bge */
  NO_FLAVOR		/* op_bgt */
};
