/*
 * Copyright (C) 1998 by the Board of Trustees
 *    of Leland Stanford Junior University.
 * Copyright (C) 1998 Digital Equipment Corporation
 *
 * This file is part of the SimOS distribution.
 * See LICENSE file for terms of the license.
 *
 */



#ifndef ALPHA_ACCESS_H
#define ALPHA_ACCESS_H


#define ALPHA_ACCESS_VERSION (1291+1) /* CH++*/

typedef struct AlphaAccess {
   int last_offset; /* must be first field */
   int version;
   int numCPUs; 
   long mem_size;
   long cpuClock; /*MHz*/
   int intrClockFrequency; /* Hz */
   
   /* Loaded kernel */
   long kernStart;
   long kernEnd;
   long entryPoint;

   /* console disk stuff */
   long diskUnit;
   long diskCount;
   long diskPAddr;
   long diskBlock;
   long diskOperation;

   /* console simple output stuff */
   long outputChar;

   /* MP boot */
   long bootStrapImpure;
   int bootStrapCPU;

} AlphaAccess;


extern AlphaAccess alphaAccess;

#endif

