/*
 * Copyright (C) 1996-1998 by the Board of Trustees
 *    of Leland Stanford Junior University.
 * 
 * This file is part of the SimOS distribution. 
 * See LICENSE file for terms of the license. 
 *
 */

#ifndef CLOCK_H
#define CLOCK_H

#include "simmisc.h"

void Embra_Clock_Init(int cpuNum);
extern void EmbraClosePeriodicCallbacks(void);

void EmIntrBitsChanged(int cpuNum);
int  Update_And_Check_Interrupts( int cpuNum, VA targetPC );
extern void (*EmEventPoll)(void);
void EmbraMakeProcExit( int cpuNum);
SimTime EmbraReadTime( void );
SimTime EmbraCpuCycleCount( int cpuNum);

C_LINK void Embra_Send_Interrupt( int cpuNum, IEC, SimTime delay );
C_LINK void Embra_Deliver_SIPS( int cpuNum, int chan, SimTime delay );

/* Make the .cycleCount field the actual current time.  Yes this is a */
/* wierd call */
void EmbraFixCycleCounts(void );

/* This checks for interrupts and increments a time count */
C_LINK void Periodic_Callout( int cpuNum );

void EmbraClockInit(void);

#endif
