/*
 * Copyright (C) 1996-1998 by the Board of Trustees
 *    of Leland Stanford Junior University.
 * 
 * This file is part of the SimOS distribution. 
 * See LICENSE file for terms of the license. 
 *
 */

#ifndef DEBUG_H
#define DEBUG_H

extern void EmbraDebugInit(void);
extern void Embra_SimosDebugBreak( int cpuNum );
extern void Embra_SimosKernDebugBreak( int cpuNum );
extern void Embra_Handle_Debug_Signal( int cpuid, int sigusr );
extern void Embra_Collect_Processes_For_Debug( int cpuNum );
extern void EmbraAnnExec(int cpuNum, AnnPtr ptr, int annType);
extern void EmbraPollSigUsr(int cpuNum);
extern Result Embra_GetRegister(int cpunum, int regnum, Reg *val);
extern Result Embra_PutRegister(int cpunum, int regnum, Reg val);
extern Result Embra_GetMemory(int cpunum, VA vAddr, uint nbytes, char *buf);
extern Result Embra_PutMemory(int cpunum, VA vAddr, uint nbytes, char *buf);
extern Result Embra_TranslateVirtualNoSE(int cpunum, VA vaddr,PA *);
extern void   EmbraSideEffect(void);
extern int    EmbraAnnType(void);
extern void   FlushTCIfNecessary(int cpunum);
#endif
