/*
 * Copyright (C) 1996 by the Board of Trustees
 *    of Leland Stanford Junior University.
 * 
 * This file is part of the SimOS distribution. 
 * See LICENSE file for terms of the license. 
 *
 */

/*****************************************************************
 * trace.h
 * 
 * Interface for basic instruction and memory reference tracing. 
 * This is an initial interface proposal, and can certainly be
 * changed as needed
 * 
 * Author: $Author: nikos $
 * Date:   $Date: 1998/02/16 23:19:32 $
 ****************************************************************/

#ifdef TRACING
void TraceInit(void);
void TraceInstruction(CPUState *P, Inst instr);
void TraceDataRef(CPUState *, VA, PA);
void TraceUncachedDataRef(CPUState *, VA, PA);
void TraceCheckASID(CPUState *);
void TraceException(CPUState *P, int code);
extern int TraceDumpTclCmd(ClientData clientData, Tcl_Interp *interp, 
                           int argc, char *argv[]);
#else
# define TraceInit() ;
# define TraceInstruction(_P, _i) ;
# define TraceMemRef(_P, _va, _pa) ;
# define TraceCheckASID(_P);
# define TraceDataRef(_P, _va, _pa) ;
# define TraceUncachedDataRef(_P, _va, _pa) ;
# define TraceException(_P, _c);
#endif


