/*
 * Copyright (C) 1996-1998 by the Board of Trustees
 *    of Leland Stanford Junior University.
 * 
 * This file is part of the SimOS distribution. 
 * See LICENSE file for terms of the license. 
 *
 */

/*****************************************************************
 * solo_extras.h
 * 
 * This is the interface between solo and solo mipsy. 
 *****************************************************************/

#ifndef _SOLOEXTRA_H_
#define _SOLOEXTRA_H_

extern void MipsySoloInit(void);
extern void MipsyStopCPU(int cpuNum);
extern void MipsyStartCPU(int cpuNum, VA pc, VA ra, VA stackStart);
extern void MipsySoloSync(int cpuNum);
extern int MipsyFlushCacheLine(int cpuNum, VA va);


/* These functions are exported so that syscall.c can use them too */
extern int SoloReadByte(int cpuNum, VA addr, char *data);
extern int SoloWriteByte(int cpuNum, VA addr, char data);
extern void MipsyHandleSyscall(CPUState *);

#endif


