// simosinterface.h
//   Include file defining the interface between Simos and flashlite
//   
//   Mendel Rosenblum
//   Sept 1994
//

// *************************************************************************
// *                                                                       *
// *               Copyright (C) 1993-1998 Stanford University             *
// *                                                                       *
// *  These coded instructions, statements, and computer programs contain  *
// *  unpublished proprietary information of Stanford University, and      *
// *  are protected by Federal copyright law.  They may not be disclosed   *
// *  to third parties or copied or duplicated in any form, in whole or    *
// *  in part, without the prior written consent of Stanford University.   *
// *                                                                       *
// *************************************************************************

#ifndef SIMOSINTERFACE_H
#define SIMOSINTERFACE_H

#include "flashtypes.h"

void SimosCmdToSimos(int cpunum, int transId, int cmd, LL address, int *cacheState,
                     unsigned char *data, uint errorVec);

Bool SimosGetMemoryAddr(LL p_addr, Address *addr, int mem_type);

int  SimosDispatchPIO(int node_num, uint address, int isRead, int size, 
                      volatile void *data);

int  SimosSetIntrBits(int cpunum, uint enableMask, uint intrBits);

#endif



